#if !defined(_DISPLAY_H)
#define _DISPLAY_H

#include <WiFi.h>
#include <Wire.h>
#include "SSD1306Wire.h"
#include <config.h>
#include <pocsag_transmitter.h>

void display_setup();
// void display_loop(bool transmitterActive);
void display_loop(bool transmitterActive, POCSAGTransmitter *transmitter);
void display_loop(bool transmitterActive, POCSAGTransmitter *transmitter, cfg_t *cfg_ref);
void display_loop(bool transmitterActive, POCSAGTransmitter *transmitter, cfg_t *cfg_ref, char *timeStr);

void display_update_state_draw();
void display_update_state(const char *text);


void display_report(const char *text);


#endif